namespace com.docusign.connect;
using org.accordproject.runtime;
using org.accordproject.binary;
using AccordProject.Concerto;
[System.Text.Json.Serialization.JsonConverter(typeof(System.Text.Json.Serialization.JsonStringEnumConverter))]
public enum EnvelopeStatusCode {
      Any,
      Voided,
      Created,
      Deleted,
      Sent,
      Delivered,
      Signed,
      Completed,
      Declined,
      TimedOut,
      Template,
      Processing,
}
[System.Text.Json.Serialization.JsonConverter(typeof(System.Text.Json.Serialization.JsonStringEnumConverter))]
public enum RecipientStatusCode {
      Created,
      Sent,
      Delivered,
      Signed,
      Declined,
      Completed,
      FaxPending,
      AutoResponded,
}
[System.Text.Json.Serialization.JsonConverter(typeof(System.Text.Json.Serialization.JsonStringEnumConverter))]
public enum TabTypeCode {
      InitialHere,
      SignHere,
      FullName,
      FirstName,
      LastName,
      EmailAddress,
      Company,
      Title,
      DateSigned,
      InitialHereOptional,
      EnvelopeID,
      Custom,
      SignerAttachment,
      SignHereOptional,
      Approve,
      Decline,
      SignerAttachmentOptional,
      DigitalSignature,
}
[System.Text.Json.Serialization.JsonConverter(typeof(System.Text.Json.Serialization.JsonStringEnumConverter))]
public enum CustomTabTypeCode {
      Text,
      Checkbox,
      Radio,
      List,
      Date,
      Number,
      SSN,
      ZIP5,
      ZIP5DASH4,
      Email,
      Note,
      Formula,
}
[System.Text.Json.Serialization.JsonConverter(typeof(System.Text.Json.Serialization.JsonStringEnumConverter))]
public enum DocumentType {
      Principal,
      CertificateOfCompletion,
      SignerAttachment,
}
[AccordProject.Concerto.Type(Namespace = "com.docusign.connect", Version = "0.4.0", Name = "EnvelopeStatus")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class EnvelopeStatus : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "com.docusign.connect@0.4.0.EnvelopeStatus";
   public EnvelopeStatusCode status { get; set; }
   public string envelopeId { get; set; }
   public System.DateTime? created { get; set; }
   public System.DateTime? sent { get; set; }
   public System.DateTime? delivered { get; set; }
   public System.DateTime? signed { get; set; }
   public System.DateTime? completed { get; set; }
   public System.DateTime? declined { get; set; }
   public string email { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "com.docusign.connect", Version = "0.4.0", Name = "Recipient")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Recipient : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "com.docusign.connect@0.4.0.Recipient";
   public RecipientStatusCode status { get; set; }
   public string email { get; set; }
   public string userName { get; set; }
   public System.DateTime? sent { get; set; }
   public System.DateTime? delivered { get; set; }
   public System.DateTime? signed { get; set; }
   public System.DateTime? declined { get; set; }
   public string declineReason { get; set; }
   public TabStatus?[] tabStatuses { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "com.docusign.connect", Version = "0.4.0", Name = "CustomField")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class CustomField : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "com.docusign.connect@0.4.0.CustomField";
   public string name { get; set; }
   public string value { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "com.docusign.connect", Version = "0.4.0", Name = "TabStatus")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class TabStatus : Concept {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "com.docusign.connect@0.4.0.TabStatus";
   public TabTypeCode tabType { get; set; }
   public string status { get; set; }
   public string tabLabel { get; set; }
   public string originalValue { get; set; }
   public System.DateTime? signed { get; set; }
   public CustomTabTypeCode? customTabType { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "com.docusign.connect", Version = "0.4.0", Name = "NumberTabStatus")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class NumberTabStatus : TabStatus {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "com.docusign.connect@0.4.0.NumberTabStatus";
   public string tabName { get; set; }
   public float? tabValue { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "com.docusign.connect", Version = "0.4.0", Name = "TextTabStatus")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class TextTabStatus : TabStatus {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "com.docusign.connect@0.4.0.TextTabStatus";
   public string tabName { get; set; }
   public string tabValue { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "com.docusign.connect", Version = "0.4.0", Name = "DateTabStatus")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class DateTabStatus : TabStatus {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "com.docusign.connect@0.4.0.DateTabStatus";
   public string tabName { get; set; }
   public System.DateTime? tabValue { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "com.docusign.connect", Version = "0.4.0", Name = "BooleanTabStatus")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class BooleanTabStatus : TabStatus {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "com.docusign.connect@0.4.0.BooleanTabStatus";
   public string tabName { get; set; }
   public bool? tabValue { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "com.docusign.connect", Version = "0.4.0", Name = "ListTabStatus")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class ListTabStatus : TabStatus {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "com.docusign.connect@0.4.0.ListTabStatus";
   public string[] tabNames { get; set; }
   public string tabValue { get; set; }
   public string[] listValues { get; set; }
   public string listSelectedValue { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "com.docusign.connect", Version = "0.4.0", Name = "Attachment")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class Attachment : BinaryResource {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "com.docusign.connect@0.4.0.Attachment";
   public DocumentType docType { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "com.docusign.connect", Version = "0.4.0", Name = "DocuSignEnvelopeInformation")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class DocuSignEnvelopeInformation : Request {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "com.docusign.connect@0.4.0.DocuSignEnvelopeInformation";
   public EnvelopeStatus envelopeStatus { get; set; }
   public Recipient?[] recipients { get; set; }
   public CustomField?[] customFields { get; set; }
   public Attachment?[] attachments { get; set; }
}
